/***************************************************************************
                         FloatRenderCanvas.h
 ---------------------------------------------------------------------------
     begin                : 2003
     copyright            : (C) 2003 by Sabrina Skibak
     email                : sabrina.skibak@informatik.uni-ulm.de
 ***************************************************************************/

#ifndef FLOATRENDERCANVAS_H
#define FLOATRENDERCANVAS_H

#include <windows.h>
#include <cmath>

#include "AbstractRenderCanvas.h"
#include "SDLRenderCanvas.h"


/**
 *
 */
class FloatRenderCanvas : public AbstractRenderCanvas
{
public:
	float* m_pData;

public:
	FloatRenderCanvas(int f_XRes, int f_YRes);
	~FloatRenderCanvas(void);

	bool Initialize();

	void EnterRenderMode();

	void LeaveRenderMode();

	/**
	* This method has to be implemented by the actual canvas implementation.
	*/
	void DrawPixel(int f_X, int f_Y, float f_R, float f_G, float f_B);

	//does some boundary checking
	void DrawSafePixel(int f_X, int f_Y, float f_R, float f_G, float f_B);

	void DrawPixelUchar(int f_X, int f_Y, unsigned char f_R, unsigned char  f_G, unsigned char  f_B);

	void GetPixelColor(int f_X, int f_Y, float& f_R, float& f_G, float& f_B);

	int GetXResolution() {return m_XResolution;};
	int GetYResolution() {return m_YResolution;};

	/**
	* This method should return a float array (RGB) of the image. Generally the returnend
	* image array should not be modified because it is up to the image canvas to
	* return either a copy or its internal float array...
	*/
	float* GetImageCopy(float* f_pDestination = NULL);

	/**
	 * Loads an image file.
	 */
	void Load(const char* f_pFilename);

	void clearFloatBuffer(float f_Color);
	void clearFloatBuffer(float f_R, float f_G, float f_B);

	void CopyCanvas(SDLRenderCanvas* f_pCanvas);

};

#endif;