/***************************************************************************
                         SDLOpenGLRenderCanvas.h
 ---------------------------------------------------------------------------
     begin                : Mi Aug 20 2003
     copyright            : (C) 2002 by Holger Dammertz
     email                : holger.dammertz@informatik.uni-ulm.de
 ***************************************************************************/

#ifndef SDLOPENGLRENDERCANVAS_H
#define SDLOPENGLRENDERCANVAS_H

#include <windows.h>
#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "SDLRenderCanvas.h"


class SDLOpenGLRenderCanvas : public SDLRenderCanvas
{
	float* m_pImageBuffer;

	/** A pointer to our screen */
	SDL_Surface* m_pScreen;

	Uint32* m_pImage;

	/** stores some information */
	const SDL_VideoInfo* m_pVideoInfo;
	/** The video flags that define the propperties of the screen */
	int m_VideoFlags;

	bool m_FullScreen;
	/** This is used for event handling (at the moment only checking 
	    for an exit action)	*/
	SDL_Event m_Event;
	/** This is a pointer to the function that is called on a quit event */
	void (*m_fpQuitFunction)(int);

public:
	SDLOpenGLRenderCanvas(int f_XRes, int f_YRes, bool f_FullScreen);
	~SDLOpenGLRenderCanvas();

	virtual bool Initialize();

	//virtual void DrawPixel(int f_X, int f_Y, RGBColor& f_rColor);

	void SetQuitFunction(void (*f_fpQuitFunction)(int));

	//virtual void HandleEvents();

	virtual void EnterRenderMode();

	virtual void LeaveRenderMode();

	/**
	 * A utlitiy function that draws a AABB.
	 */
	virtual void DrawAABB(float min_x, float min_y, float min_z, float max_x, float max_y, float max_z);

	virtual void DrawPixel(int f_X, int f_Y, float f_R, float f_G, float f_B);

	virtual void GetPixelColor(int f_X, int f_Y, float& f_R, float& f_G, float& f_B);

	virtual void DrawCircle(float f_Radius, float f_mx, float f_my, float f_Col_r,
							float f_Col_g, float f_Col_b, float f_Opacity);

  protected:
	virtual void SetVideoFlags(bool f_PrintInfo);

};

#endif
